<?php

namespace Drupal\Tests\prometheusio_exporter\Unit\Plugin\MetricsCollector;

use Drupal\Tests\UnitTestCase;
use Drupal\prometheusio_exporter\Bridge\PrometheusBridge;
use Drupal\Core\Site\Settings;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\prometheusio_exporter\MetricsCollectorManager;
use Drupal\prometheusio_exporter\Prometheus\Storage\DrupalCache;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Cache\MemoryBackend;

abstract class AbstractTestBaseMetrics extends UnitTestCase {

    protected function setUp(): void
    {
        $drupalCache = new DrupalCache(new MemoryBackend);
        $settings = new Settings(['prometheus_metrics_storage_type' => 'drupalcache']);
        $prometheusBridge = new PrometheusBridge($settings, $drupalCache);
        $container = $this->prophesize(ContainerInterface::class);
        $mcm = $this->prophesize(MetricsCollectorManager::class);
        $container->get('prometheusio_exporter.metrics_collector_manager')->willReturn($mcm);
        $prometheusBridge->setContainer($container->reveal());
        $this->prometheusBridge = $prometheusBridge;
    }
}
